; #########################################################################
; Simple BASS WMA Player in MASM32 
; by TBD (16.Apr.2oo2)
;
; MASM32 package (c) Steve 'Hutch' Hutchesson http://www.movsd.com
; BASS and BASS WMA engine (c) Ian Luck  http://www.un4seen.com/music/
; #########################################################################

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\user32.inc
      include \masm32\include\comdlg32.inc
      include bass.inc
      include basswma.inc


;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib bass.lib
      includelib basswma.lib
      
      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM



.data 
      szFileName     db 260 dup(0)
      szClassName    db "BASSWMA_Player",0
      szText         db "Simple BASS WMA Player",13,10,"Copyright  TBD 2oo2",0
      szOpen         db "Open A File",0
      szFiles        db "WMA Files",0,"*.wma",0,0      
  
.data?
      hInstance     dd ?
      hWMA          dd ?
      ofn           OPENFILENAME <>  ; structure    
      
.code

; #########################################################################

start:

        invoke GetModuleHandle, NULL
        mov hInstance, eax
        
        mov ofn.lStructSize, sizeof OPENFILENAME
        m2m ofn.hWndOwner,   0
        m2m ofn.hInstance,   hInstance
        m2m ofn.lpstrFilter, offset szFiles             
        m2m ofn.lpstrFile,   offset szFileName
        mov ofn.nMaxFile,    sizeof szFileName
        m2m ofn.lpstrTitle,  offset szOpen
        mov ofn.Flags,       OFN_EXPLORER or OFN_FILEMUSTEXIST or \
                             OFN_LONGNAMES
        
        invoke GetOpenFileName,ADDR ofn                         ; get filename from user
        cmp szFileName[0],0                                     ; zero if cancel pressed in dlgbox
        je error
        
        invoke BASS_Init, -1, 44100, BASS_DEVICE_3D, 0          ; BASS_Init
        test eax,eax                                            
        jz error                                                
        
        invoke BASS_Start                                       ; start BASS engine
        test eax,eax
        jz error
        
        invoke BASS_WMA_StreamCreateFile, 0, offset szFileName, 0, 0, BASS_SAMPLE_LOOP 
        mov hWMA, eax
        
        invoke BASS_WMA_StreamPlay, hWMA, 0, BASS_SAMPLE_LOOP
        invoke MessageBox, 0,ADDR szText,ADDR szClassName,MB_OK
        invoke BASS_WMA_StreamFree, hWMA  
        invoke BASS_Free;

error:
        invoke ExitProcess, 0

end start