VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmPlayer 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "BASSWMA test: Player MOD/MPx/OGG/WAV/WMA"
   ClientHeight    =   1095
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4710
   Icon            =   "frmPlayer.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1095
   ScaleWidth      =   4710
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton btnOpen 
      Caption         =   "Open Media file && play it :)"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   4455
   End
   Begin MSComDlg.CommonDialog cmd 
      Left            =   3840
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label lblFile 
      AutoSize        =   -1  'True
      Caption         =   "File:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   285
   End
End
Attribute VB_Name = "frmPlayer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'////////////////////////////////////////////////////////////////
' Please report bugs/suggestions/etc... to bass@un4seen.com
' --------------------------------------------------------------
' frmPlayer.frm - Copyright (c) 2002
'                          JOBnik! [Arthur Aminov, ISRAEL]
'                          e-mail: jobnik2k@hotmail.com
'
' Simple Player: MOD/MPx/OGG/WAV/WMA...
'
' Requires BASS.DLL & BASS.BAS 1.6 - available @ www.un4seen.com
'////////////////////////////////////////////////////////////////

Dim chan As Long

Private Sub btnOpen_Click()
    On Error Resume Next    'if Cancel pressed...
    
    cmd.CancelError = True
    cmd.flags = cdlOFNExplorer Or cdlOFNFileMustExist Or cdlOFNHideReadOnly
    cmd.DialogTitle = "Select a file to play"
    cmd.Filter = "Playable files (*.mo3;*.xm;*.mod;*.s3m;*.it;*.mtm;*.umx;*.mp?;*.ogg;*.wav;*.wma;*.wmv)|*.mo3;*.xm;*.mod;*.s3m;*.it;*.mtm;*.umx;*.mp?;*.ogg;*.wav;*.wma;*.wmv|All files (*.*)|*.*"
    cmd.ShowOpen
    
    'because that CommonDialog is changing and setting
    'a file path, we must write next 2 lines
    'to make sure that - basswma.dll - is found
    'or you can simply copy this .dll to win\system path :)
    ChDrive App.Path
    ChDir App.Path
    
    'if cancel was pressed, exit the procedure
    If Err.Number = 32755 Then Exit Sub
    
    ' free both MOD and stream, it must be one of them! :)
    Call BASS_StreamFree(chan)
    Call BASS_MusicFree(chan)
     
    chan = BASS_StreamCreateFile(BASSFALSE, cmd.FileName, 0, 0, 0)
    If chan = 0 Then chan = BASS_WMA_StreamCreateFile(BASSFALSE, cmd.FileName, 0, 0, 0) 'it's a WMA?
    If chan = 0 Then chan = BASS_MusicLoad(BASSFALSE, cmd.FileName, 0, 0, BASS_MUSIC_LOOP Or BASS_MUSIC_RAMP)
    
    ' whatever it is, it ain't playable
    If chan = 0 Then
        Call MsgBox("Error: Selected file couldn't be played!", vbCritical)
        Exit Sub
    End If
    
    If (BASS_WMA_GetIWMReader(chan) > 0) Then ' check if it's a WMA channel
        Call BASS_WMA_StreamPlay(chan, 0, BASS_SAMPLE_LOOP)
    Else
        ' play both MOD and stream, it must be one of them! :)
        Call BASS_MusicPlay(chan)
        Call BASS_StreamPlay(chan, 0, BASS_SAMPLE_LOOP)
    End If
    
    lblFile.Caption = "File: " & GetFileName(cmd.FileName)

End Sub

Private Sub Form_Load()
    
    'change and set the current path
    'so it won't ever tell you that bass.dll & basswma.dll are not found
    ChDrive App.Path
    ChDir App.Path
    
    'check if 'bass.dll' is exists
    If FileExists(RPP(App.Path) & "bass.dll") = False Then
        MsgBox "BASS.DLL does not exists", vbCritical, "BASS.DLL"
        End
    End If
    
    'check if 'basswma.dll' is exists
    If FileExists(RPP(App.Path) & "basswma.dll") = False Then
        MsgBox "BASSWMA.DLL does not exists", vbCritical, "BASSWMA.DLL"
        End
    End If
    
    'Check that BASS 1.6 was loaded
    If BASS_GetStringVersion <> "1.6" Then
        MsgBox "BASS version 1.6 was not loaded", vbCritical, "BASS.DLL"
        End
    End If
    
    'setup output - default device, 44100hz, stereo, 16 bits, no syncs (not used)
    If (BASS_Init(-1, 44100, 0, Me.hWnd) <> 0) Then
        BASS_Start
    Else
        MsgBox "Error: Can't initialize device", vbCritical, "Digital output"
        End
    End If

End Sub

Private Sub Form_Unload(Cancel As Integer)
    Call BASS_Free
End Sub

'some useful functions :)

'check if any file exists
Public Function FileExists(FileName) As Boolean
    On Local Error Resume Next
    FileExists = (Dir$(FileName) <> "")
End Function

' RPP = Return Proper Path
Public Function RPP(ByVal fp As String) As String
    RPP = IIf(Mid(fp, Len(fp), 1) = "\", fp, fp & "\")
End Function

'get file name from file path
Public Function GetFileName(ByVal fp As String) As String
    GetFileName = Mid(fp, InStrRev(fp, "\") + 1)
End Function
